<template>
    <div>
        <div class="container">
            <h1 class="h1">
                Horarios del doctor(a) {{ userInfo.nombres }} {{ userInfo.apellidos }}
                <span class="text-danger">{{ estado }}</span>
            </h1>
            <NuxtLink :to="`/user`">&#60; Ver usuarios.</NuxtLink>
            &nbsp;&nbsp;
            <NuxtLink :to="`/user/get/horario-${id}`">&#62; Registrar horario.</NuxtLink>
            <hr class="margin-top-10">
            <table class="full-width table table-hover table-bordered table-sm">
                <thead>
                    <tr>
                        <th width="5%">#</th>
                        <th width="50%">Día</th>
                        <th>Horario</th>
                        <th colspan="2"></th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(itemH, idx) in listaHorarios" :key="idx">
                        <td class="text-center">{{ itemH.id }}</td>
                        <td class="text-center">{{ itemH.diaSemana }}</td>
                        <td class="text-center">{{ forceToTime(itemH.horaInicio) }} - {{ forceToTime(itemH.horaFin) }}</td>
                        <td class="text-center" width="6%">
                            <NuxtLink :to="`/user/get/horario-${id}/${itemH.id}`">Editar</NuxtLink>
                        </td>
                        <td class="text-center" width="6%">
                            <NuxtLink :to="`/user/get/horario-${id}/${itemH.id}?a=2`">Eliminar</NuxtLink>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</template>

<script setup lang="ts">
    import { forceToTime } from '~/server/utils/common/date-and-time';

    const routerInstance = (useRouter());
    const id = ref(routerInstance.currentRoute.value.params.id.toString());

    const userInfo:any = ref(await $fetch(`/api/user?id=${id.value}`, {   
        method: 'GET',
        headers: { 'method': 'findRecord' }
    }));

    const listaHorarios: any = (await $fetch(`/api/horario?id=${id.value}`, {   
        method: 'GET',
        headers: { 'method': 'getByMedicId' }
    }));

    let estado = ref('');

    function detectarEstado() {
        const diasSemana = ['Domingo', 'Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sábado'];
        const fechaActual = new Date();
        const diaSemana = diasSemana[fechaActual.getDay()];

        let diasRegistrados = listaHorarios.filter(function (item: any) {
            return diaSemana === item.diaSemana;
        });

        if (diasRegistrados.length > 0) {
            let hi = forceToTime(diasRegistrados[0].horaInicio).split(':').join('');
            let hf = forceToTime(diasRegistrados[0].horaFin).split(':').join('');
            console.log({hi, hf});

            let fechaActual = new Date();
            let HoraActual = fechaActual.getHours() + '' + fechaActual.getMinutes();
            if (parseInt(HoraActual) >= parseInt(hi) && parseInt(HoraActual) <= parseInt(hf)) {
                estado.value = 'Ocupado'
            }
            
        }
    }
    detectarEstado();


    
</script>